Package tigase.xmpp.impl

# Class JabberIqPrivacy

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.JabberIqPrivacy

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `Initializable`, `RegistrarBean`, `UnregisterAware`, `XMPPImplIfc`, `XMPPPacketFilterIfc`, `XMPPPreprocessorIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="jabber:iq:privacy", parent=SessionManager.class, active=true) public class JabberIqPrivacy extends XMPPProcessor implements XMPPProcessorIfc, XMPPPreprocessorIfc, XMPPPacketFilterIfc, RegistrarBean, Initializable, UnregisterAware
Describe class JabberIqPrivacy here.
Created: Mon Oct 9 18:18:11 2006

Author:
  Artur Hefczyc

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected static enum`
  `JabberIqPrivacy.ITEM_ACTION`
  `protected static enum`
  `JabberIqPrivacy.ITEM_SUBSCRIPTIONS`
  `protected static enum`
  `JabberIqPrivacy.ITEM_TYPE`
  `static class`
  `JabberIqPrivacy.OfflineResourceConnection`
  `static class`
  `JabberIqPrivacy.PrivacyListOfflineCache`
  `static class`
  `JabberIqPrivacy.PrivacyListUpdatedEvent`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ACTIVE_EL_NAME`
  `protected static final Element`
  `BLOCKED_ELEM`
  `protected JabberIqPrivacy.PrivacyListOfflineCache`
  `cache`
  `protected static final Comparator<Element>`
  `compar`
  `protected static final String`
  `DEFAULT_EL_NAME`
  `protected static final Element[]`
  `DISCO_FEATURES`
  `protected static final String[][]`
  `ELEMENTS`
  `protected static final String`
  `ERROR_EL_NAME`
  `protected static final String`
  `ID`
  `protected static final String`
  `LIST_EL_NAME`
  `protected static Logger`
  `log`
  `protected static final String`
  `PRESENCE_EL_NAME`
  `protected static final String`
  `PRESENCE_IN_EL_NAME`
  `protected static final String`
  `PRESENCE_OUT_EL_NAME`
  `protected static RosterAbstract`
  `roster_util`
  `protected static final String`
  `XMLNS`
  `protected static final String[]`
  `XMLNSS`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JabberIqPrivacy()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `allowed(Packet packet, JID connId, BareJID userJid, PrivacyList privacyList)`
  `protected boolean`
  `allowed(Packet packet, XMPPResourceConnection session)`
  `protected boolean`
  `allowedByDefault(Packet packet, JID connId, BareJID userJid)`
  `void`
  `beforeUnregister()`
  Method called before bean unregister.
  `void`
  `filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)`
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `void`
  `initialize()`
  Method will be called, when bean will be created, configured and ready to use.
  `protected Packet`
  `prepareError(Packet packet, XMPPResourceConnection session)`
  `boolean`
  `preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  Performs pre-processing of `packet`.
  `void`
  `privacyListUpdated(JabberIqPrivacy.PrivacyListUpdatedEvent event)`
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `protected void`
  `processGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results)`
  `protected void`
  `processSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results)`
  `void`
  `register(Kernel kernel)`
  Method called when bean is being registered allowing developer to programatically register other beans.
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
  `void`
  `unregister(Kernel kernel)`
  Method called while bean is being unregistered.
  `static Authorization`
  `validateList(XMPPResourceConnection session, List<Element> items)`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supStreamFeatures, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supStreamFeatures, supTypes`

- ## Field Details

  - ### ACTIVE_EL_NAME

    protected static final String ACTIVE_EL_NAME
    See Also:
      - Constant Field Values

  - ### BLOCKED_ELEM

    protected static final Element BLOCKED_ELEM

  - ### DEFAULT_EL_NAME

    protected static final String DEFAULT_EL_NAME
    See Also:
      - Constant Field Values

  - ### ELEMENTS

    protected static final String[][] ELEMENTS

  - ### LIST_EL_NAME

    protected static final String LIST_EL_NAME
    See Also:
      - Constant Field Values

  - ### ERROR_EL_NAME

    protected static final String ERROR_EL_NAME
    See Also:
      - Constant Field Values

  - ### PRESENCE_EL_NAME

    protected static final String PRESENCE_EL_NAME
    See Also:
      - Constant Field Values

  - ### PRESENCE_IN_EL_NAME

    protected static final String PRESENCE_IN_EL_NAME
    See Also:
      - Constant Field Values

  - ### PRESENCE_OUT_EL_NAME

    protected static final String PRESENCE_OUT_EL_NAME
    See Also:
      - Constant Field Values

  - ### XMLNS

    protected static final String XMLNS
    See Also:
      - Constant Field Values

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

  - ### XMLNSS

    protected static final String[] XMLNSS

  - ### DISCO_FEATURES

    protected static final Element[] DISCO_FEATURES

  - ### compar

    protected static final Comparator<Element> compar

  - ### log

    protected static Logger log

  - ### roster_util

    protected static RosterAbstract roster_util

  - ### cache

    @Inject(nullAllowed=true) protected JabberIqPrivacy.PrivacyListOfflineCache cache

- ## Constructor Details

  - ### JabberIqPrivacy

    public JabberIqPrivacy()

- ## Method Details

  - ### validateList

    public static Authorization validateList(XMPPResourceConnection session, List<Element> items)

  - ### register

    public void register(Kernel kernel)
    Description copied from interface: `RegistrarBean`
    Method called when bean is being registered allowing developer to programatically register other beans.
    Specified by:
      `register` in interface `RegistrarBean`
    Parameters:
      `kernel` - - instance from local scope

  - ### unregister

    public void unregister(Kernel kernel)
    Description copied from interface: `RegistrarBean`
    Method called while bean is being unregistered.
    Specified by:
      `unregister` in interface `RegistrarBean`
    Parameters:
      `kernel` - - instance from local scope

  - ### filter

    public void filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)
    Specified by:
      `filter` in interface `XMPPPacketFilterIfc`

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### preProcess

    public boolean preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)
    Performs pre-processing of `packet`. Intention for the pre-processors is to allow them for packet blocking.
    `preProcess` method checks only incoming stanzas so it doesn't check for presence-out at all.
    Specified by:
      `preProcess` in interface `XMPPPreprocessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Returns:
      the pre-processing result; if the value is ‘true’ then the packet is blocked and no further processing is performed.

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `XMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `XMPPProcessor`
    Returns:
      a `String[]` value

  - ### initialize

    public void initialize()
    Description copied from interface: `Initializable`
    Method will be called, when bean will be created, configured and ready to use.
    Specified by:
      `initialize` in interface `Initializable`

  - ### beforeUnregister

    public void beforeUnregister()
    Description copied from interface: `UnregisterAware`
    Method called before bean unregister.
    Specified by:
      `beforeUnregister` in interface `UnregisterAware`

  - ### privacyListUpdated

    @HandleEvent public void privacyListUpdated(JabberIqPrivacy.PrivacyListUpdatedEvent event)

  - ### allowed

    protected boolean allowed(Packet packet, JID connId, BareJID userJid, PrivacyList privacyList)

  - ### allowed

    protected boolean allowed(Packet packet, XMPPResourceConnection session)

  - ### allowedByDefault

    protected boolean allowedByDefault(Packet packet, JID connId, BareJID userJid)

  - ### prepareError

    protected Packet prepareError(Packet packet, XMPPResourceConnection session)

  - ### processGetRequest

    protected void processGetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results) throws NotAuthorizedException, XMPPException, TigaseDBException
    Throws:
      `NotAuthorizedException`
      `XMPPException`
      `TigaseDBException`

  - ### processSetRequest

    protected void processSetRequest(Packet packet, XMPPResourceConnection session, Queue<Packet> results) throws NotAuthorizedException, XMPPException, TigaseDBException
    Throws:
      `NotAuthorizedException`
      `XMPPException`
      `TigaseDBException`